#include <LEDA/polygon.h>
#include <LEDA/gen_polygon.h>
#include <LEDA/window.h>
#include <LEDA/geowin.h>

using namespace leda;


class Winding_number {
   public:
       bool winding_number(const polygon& P, const point p);
};

    
bool Winding_number::winding_number(const polygon& P, const point p)
{
   const double PI= 3.14159265358979323846;
   double angle_value, anglesum;
   segment s;
   polygon Q;
   
   if (P.orientation() == -1) Q = P.complement();
   else Q = P;

   anglesum = 0;
   
   forall_segments (s, Q) 
   {
      segment a (p, s.start());
      segment b (p, s.end());
      angle_value = a.angle(b) * 180 / PI;
      if (angle_value > 180) angle_value = 360 - angle_value;
      anglesum = anglesum +  orientation (s, p) * angle_value;
   }

   if (anglesum > 359 && anglesum < 361) return true;
   else return false;
}

